#include <stdio.h>
#include <klic/gdobject.h>
#include <klic/interpe.h>
#include <klic/traceio.h>

#include "atom.h"
#include "funct.h"

#include <pk_struct.h>

#ifdef DEBUG
#define INT_CL_DEBUG
#endif

#define GC_CLASS_NAME() read_all_hook
#define GC_OBJ_TYPE struct read_all_hook_object
#define GC_OBJ_SIZE(obj)  G_SIZE_IN_Q(GC_OBJ_TYPE)

#include <klic/gc_macro.h>
#include <klic/gd_macro.h>
#include <pk_macro.h>

GCDEF_UNIFY()
{
  G_STD_DECL;

  GC_SWITCH_ON_TERM(list0,atomic0,functor0,generic_data0,susp0);

 list0:
 atomic0:
 functor0:
 generic_data0:
  if(receive_answer_flag){
    if((GC_SELF->return_index) == answer_return_exp_index){

			INT_CL_DEBUG_X(iosprintf("%d:rd_a_hok receive answer value -> no send_release \n",my_node));

/*   answer_value message $B$K$h$k(Bunify  */
/*
			INT_CL_DEBUG_X(klic_fprintf(stdout,
				  "rdhok receive answer value -> send_release \n"));
*/
/*      send_release(GC_SELF->node, GC_SELF->index, GC_SELF->wec); */
/* $B$3$NJ}<0$@$H(Brelease message$B$OMW$i$J$$(B                           */

    } else {

/*   $B<+%N!<%I$G$N(Bunify  */
/*
      INT_CL_DEBUG_X(klic_fprintf(stdout,
											"rdhok receive answer value -> send_unify \n"));
*/
      INT_CL_DEBUG_X(iosprintf("rdhok receive answer value -> send_unify \n"));
      send_unify(GC_SELF->node, GC_SELF->index, GC_SELF->wec, GC_TERM);
    }      
  } else {
    INT_CL_DEBUG_X(klic_fprintf(stdout,
				"rdhok active unify -> send_unify \n"));
    send_unify(GC_SELF->node, GC_SELF->index, GC_SELF->wec, GC_TERM);
  }
  GC_SELF->node = 0;
  GC_SELF->index = 0;
  GC_SELF->wec = 0;

  GC_TERMINATE;
 susp0:
  fatal("illetal data for unify rdallhok");
}

GCDEF_GC()
{
  G_STD_DECL;
  GC_OBJ_TYPE *newself;

  INT_CL_DEBUG_X(iosprintf("%d:readallhook GC invoked\n",my_node));
  GCSET_NEWOBJ_IN_NEWGEN(newself);

  newself->node = GC_SELF->node;
  newself->index = GC_SELF->index;
  newself->wec = GC_SELF->wec;
  newself->return_index = GC_SELF->return_index;

  G_COPY_KL1_TERM_TO_NEWGEN(GC_SELF->to_read_hook, newself->to_read_hook);

  GC_RETURN_FROM_GC(newself);
}

GCDEF_PRINT()
{}


#define GCUSE_MY_UNIFY
#define GCUSE_MY_GC
#define GCUSE_MY_PRINT


#include <klic/gc_methtab.h>

GCDEF_NEW() /* node, index, wec */
{
  GC_STD_DECL_FOR_NEW;
  GC_OBJ_TYPE *new_readallhook;
	long goalnum;
	q var;

  GCSET_READALLOBJ_FOR_NEW(new_readallhook, GC_OBJ_SIZE(new_readallhook));
  new_readallhook->node   = (long)intval(GC_ARGV[0]);
  new_readallhook->index  = (long)intval(GC_ARGV[1]);
  new_readallhook->wec    = (long)intval(GC_ARGV[2]);
	new_readallhook->to_read_hook = GC_MAKE_HOOK_VAR(new_readallhook);

	goalnum = (long)intval(GC_ARGV[3]);

  new_readallhook->return_index =  send_read_all(new_readallhook->node, 
					   new_readallhook->index,
					   new_readallhook->to_read_hook, goalnum);
  new_readallhook->wec--;

  GC_RETURN_FROM_NEW(new_readallhook->to_read_hook);
}
 
