#include <stdio.h>
#include <klic/gdobject.h>
#include <klic/interpe.h>
#include "atom.h"
#include "funct.h"

#include <pk_struct.h> 
#include <pk_macro.h>

#define GC_CLASS_NAME() reply_all_hook
#define GC_OBJ_TYPE struct reply_all_hook_object
#define GC_OBJ_SIZE(obj)  G_SIZE_IN_Q(GC_OBJ_TYPE)


#include <klic/gc_macro.h>
#include <klic/gd_macro.h>
#include <klic/generic.h>

extern q *decode_answer_value();
extern long get_wtc();
extern void message_suspend();
extern void send_message();
extern void send_request_wtc();
extern void push_exp_table_entry();
extern q* pk_suspend_goal();
extern q* suspend_goal();
q answerhook_g_new();
q packbuf_g_new();

GCDEF_UNIFY()
{
  G_STD_DECL;
	q rdhok;
  q *allocp;
	extern struct predicate *packsend_goal[];
	struct goalrec *newgoal;

	INT_CL_DEBUG_X(iosprintf("%d:replyallhook active unify\n",my_node));
	
	GC_SWITCH_ON_TERM(list0,atomic0,functor0,generic_data0,susp0);

 list0:
 atomic0:
 functor0:
 generic_data0:
	if(GC_SELF->node != my_node){
		extern struct pk_flag *pk_flg;
		extern struct pk_flag pk_flg_tail;
		extern struct pk_flag *pk_flg_top;
		extern struct predicate **pk_goal;
		q anshok;
		q* allocp;

		if(pk_buffer_unused()){
			struct pk_flag *new_pk_flg;
			q pk_buf;

			if(g_allocp + this_more_space + 14 >= real_heaplimit){
				INT_CL_DEBUG_X(iosprintf("%d:UNIFY_PENDING \n",my_node));
				GC_TERMINATE_WITH_GCREQUEST(14);
			}  
			
			generic_arg[0] = makeint(GC_SELF->node);
			generic_arg[1] = makeint(GC_SELF->index);
			generic_arg[2] = makeint(GC_SELF->wec);
			allocp = g_allocp;
			new_generic(answerhook_g_new,3 , anshok, 0);
			g_allocp = allocp;

			new_pk_flg = (struct pk_flag *)g_allocp;
			new_pk_flg->next = &pk_flg_tail;
			new_pk_flg->value = (q)&(new_pk_flg->value);

			g_allocp += 2;

			generic_arg[0] = anshok;
			generic_arg[1] = makeint(my_node);
			generic_arg[2] = (q)&(new_pk_flg->value);
			allocp = g_allocp;
			new_generic(packbuf_g_new, 3, pk_buf, 0);
			g_allocp = allocp;

			pk_flg = new_pk_flg;
			pk_flg_top = new_pk_flg;

			newgoal = (struct goalrec *)g_allocp;
			newgoal->pred = (struct predicate *)packsend_goal[GC_SELF->goalnum];
			newgoal->args[0] = (q)GC_TERM;
			newgoal->args[1] = (q)pk_buf;
/*			newgoal->args[2] = (q)&(newgoal->args[2]); */

			g_allocp += 4;
			resume_same_prio(newgoal);
		}else{
			struct pk_flag *new_pk_flg;
			struct pk_flag *tmp_pk_flg;
			q pk_flg1;
			q pk_buf;

			if(g_allocp + this_more_space + 20 >= real_heaplimit){
				INT_CL_DEBUG_X(iosprintf("%d:UNIFY_PENDING \n",my_node));
				GC_TERMINATE_WITH_GCREQUEST(20);
			}

			generic_arg[0] = makeint(GC_SELF->node);
			generic_arg[1] = makeint(GC_SELF->index);
			generic_arg[2] = makeint(GC_SELF->wec);
			allocp = g_allocp;
			new_generic(answerhook_g_new,3 , anshok, 0);
			g_allocp = allocp;

			tmp_pk_flg = pk_flg;
			deref_pk_flg(tmp_pk_flg);
			pk_flg1 = pk_flg->value;
			new_pk_flg = (struct pk_flag *)g_allocp;
			tmp_pk_flg->next = new_pk_flg;
			new_pk_flg->next = &pk_flg_tail;
			new_pk_flg->value = (q)&(new_pk_flg->value);
			
			g_allocp += 2;

			generic_arg[0] = anshok;
			generic_arg[1] = makeint(my_node);
			generic_arg[2] = (q)&(new_pk_flg->value);
			allocp = g_allocp;
			new_generic(packbuf_g_new, 3, pk_buf, 0);
			g_allocp = allocp;

			pk_flg = new_pk_flg;

			newgoal = (struct goalrec *)g_allocp;
			newgoal->pred = (struct predicate *)packsend_goal[GC_SELF->goalnum];
			newgoal->args[0] = (q)GC_TERM;
			newgoal->args[1] = (q)pk_buf;
/*			newgoal->args[2] = (q)&(newgoal->args[2]); */
			

/*			iosprintf("%d:suspend goal in repl %d\n",my_node,pk_flg1);*/
 			g_allocp += 4;
			g_allocp = pk_suspend_goal(g_allocp, newgoal, pk_flg1);
		}
		
		heapp = g_allocp;
	}
	derefone(GC_SELF) = (q)GC_TERM;
	GC_TERMINATE;
	
 susp0:
	fatal("illetal data for unify rhook");
	
}
	

GCDEF_GC()
{
  G_STD_DECL;
  GC_OBJ_TYPE *newself;

	INT_CL_DEBUG_X(iosprintf("%d:gc in replyallhook\n",my_node));

  GCSET_NEWOBJ_IN_NEWGEN(newself);
	newself->node = GC_SELF->node;
  newself->index = GC_SELF->index;
  newself->wec = GC_SELF->wec;
	newself->goalnum = GC_SELF->goalnum;
  GC_RETURN_FROM_GC(newself);
}

GCDEF_PRINT()
{}

#define GCUSE_MY_UNIFY
#define GCUSE_MY_GC
#define GCUSE_MY_PRINT

#include <klic/gc_methtab.h>

GCDEF_NEW() 
{
  GC_STD_DECL_FOR_NEW;
  GC_OBJ_TYPE *new_reply_all_hook;
  q var;

	INT_CL_DEBUG_X(iosprintf("%d:new for replyallhook\n",my_node));

  GCSET_NEWOBJ_FOR_NEW(new_reply_all_hook, GC_OBJ_SIZE(new_reply_all_hook));

  new_reply_all_hook->node = (long)intval(GC_ARGV[0]);
  new_reply_all_hook->index  = (long)intval(GC_ARGV[1]);
  new_reply_all_hook->wec    = (long)intval(GC_ARGV[2]);
  new_reply_all_hook->goalnum    = (long)intval(GC_ARGV[3]);

  var = GC_MAKE_HOOK_VAR(new_reply_all_hook);

  GC_RETURN_FROM_NEW(var);
}
 
